<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="utf-8">
    <title>JSDoc: Source: services/UserService.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link type="text/css" rel="stylesheet" href="styles/jsdoc-default.css">
</head>

<body>

<div id="main">

    <h1 class="page-title">Source: services/UserService.js</h1>

    



    
    <section>
        <article>
            <pre class="prettyprint source linenums"><code>"use strict";
var __awaiter = (this &amp;&amp; this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const Logger_1 = require("../utils/Logger");
const index_1 = require("../models/index");
/**
 * User service layer facilitates requests from the controller &lt;/br>
 * to the database
 * @class
 * @author Farooq Ilyas
 */
class UserService {
    /**
     * Queries the database to create a user
     * @param {UserAttributes} user user attributes
     * @returns {UserInstance} user
     */
    create(user) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let userRecord = yield index_1.models.users.create(user);
                Logger_1.logger.info(`Created user with id ${userRecord.dataValues.id}`);
                return userRecord;
            }
            catch (error) {
                throw error;
            }
        });
    }
    /**
     * Queries the database to retrieve all users
     * @returns {UserInstance[]} all users
     */
    retrieve() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                let userRecords = yield index_1.models.users.findAll();
                Logger_1.logger.info(`Retrieved all users`);
                return userRecords;
            }
            catch (error) {
                throw error;
            }
        });
    }
    /**
     * Queries the database to retrieve a user given the id
     * @param {number} userId user id
     * @returns {UserInstance} upon successful retrieval
     * @returns {JSON} if user id not found
     */
    retrieveById(userId) {
        return new Promise((resolve, reject) => {
            return index_1.models.users.findOne({ where: { id: userId } })
                .then((user) => {
                if (user) {
                    Logger_1.logger.info(`Retrieved user with id ${userId}`);
                    resolve(user);
                }
                else {
                    Logger_1.logger.info(`User with id ${userId} does not exist`);
                    reject(new Error("NO_DATA"));
                }
            });
        });
    }
    /**
     * Queries the database to delete a user given the id
     * @param {number} userId userId
     * @returns {number} rows deleted
     * @returns {JSON} user if id not found
     */
    delete(userId) {
        return new Promise((resolve, reject) => {
            return index_1.models.users.destroy({ where: { id: userId } })
                .then((deletedRows) => {
                if (deletedRows > 0) {
                    Logger_1.logger.info(`Deleted user with id ${userId}`);
                    resolve(deletedRows);
                }
                else {
                    Logger_1.logger.info(`User with id ${userId} does not exist`);
                    reject(new Error("NO_DATA"));
                }
            });
        });
    }
    /**
     * Queries the database to update a user given the id
     * @param {number} userId user id
     * @param {UserAttributes} userAttributes user attributes
     * @returns {UserInstance} updated user
     */
    update(userId, userAttributes) {
        return new Promise((resolve, reject) => {
            return index_1.models.users.update(userAttributes, { where: { id: userId }, returning: true })
                .then((update) => {
                resolve(index_1.models.users.findOne({ where: { id: userId } }));
            });
        });
    }
}
exports.UserService = UserService;
exports.userService = new UserService();
</code></pre>
        </article>
    </section>




</div>

<nav>
    <h2><a href="index.html">Home</a></h2><h3>Classes</h3><ul><li><a href="BaseRouter.html">BaseRouter</a></li><li><a href="Configs.html">Configs</a></li><li><a href="CustomErrorHandler.html">CustomErrorHandler</a></li><li><a href="Database.html">Database</a></li><li><a href="DBConfig.html">DBConfig</a></li><li><a href="LoggingConfiguration.html">LoggingConfiguration</a></li><li><a href="Middleware.html">Middleware</a></li><li><a href="Server.html">Server</a></li><li><a href="ServerConfiguration.html">ServerConfiguration</a></li><li><a href="UserController.html">UserController</a></li><li><a href="UserModel.html">UserModel</a></li><li><a href="UserRouter.html">UserRouter</a></li><li><a href="UserService.html">UserService</a></li></ul>
</nav>

<br class="clear">

<footer>
    Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.5.5</a> on Mon Jul 02 2018 23:16:09 GMT+0100 (GMT Daylight Time)
</footer>

<script> prettyPrint(); </script>
<script src="scripts/linenumber.js"> </script>
</body>
</html>
